import datetime
from pathlib import Path

from fastapi import APIRouter
from fastapi.responses import HTMLResponse, RedirectResponse

from gallery.easel.core import AppRequest
from gallery.sketch.weather.model import WeatherResponse

from ..common.utils.tag import TagType, TagUtil
from ..common.utils.template import build_templates
from .filters import cloudness_icon, wind_direction_icon

templates = build_templates(
    Path(__file__).parent / "templates",
    {
        "wind_direction_icon": wind_direction_icon,
        "cloudness_icon": cloudness_icon,
    },
)


def build_weather_response(request: AppRequest, response: WeatherResponse):
    return templates.TemplateResponse(
        request=request,
        name="weather.html",
        context={
            "tag_util": TagUtil,
            "datetime": datetime,
            "response": response,
        },
    )


router = APIRouter()


@router.get("/weather", response_class=HTMLResponse)
async def get_weather_index(request: AppRequest, query: str | None = None):
    weather_api = request.app.state.api.weather
    locations = (await weather_api.find_locations(query)) if query else []
    return templates.TemplateResponse(
        request=request,
        name="index.html",
        context={
            "locations": locations,
        },
    )


@router.get("/weather/{location}", response_class=RedirectResponse)
async def get_weather_default(location: str):
    return RedirectResponse(f"{location}/tag/today")


@router.get("/weather/{location}/day/{date}", response_class=HTMLResponse)
async def get_weather_day(request: AppRequest, location: str, date: datetime.date):
    weather_api = request.app.state.api.weather
    response = await weather_api.get_day(location, date)
    return build_weather_response(request, response)


@router.get("/weather/{location}/days/{days}", response_class=HTMLResponse)
async def get_weather_days(request: AppRequest, location: str, days: int):
    weather_api = request.app.state.api.weather
    response = await weather_api.get_days(location, days)
    return build_weather_response(request, response)


@router.get("/weather/{location}/tag/{tag}", response_class=HTMLResponse)
async def get_weather_tag(request: AppRequest, location: str, tag: str):
    tag_value = TagUtil.parse_tag(tag)
    weather_api = request.app.state.api.weather
    if tag_value.type == TagType.DAY:
        response = await weather_api.get_day(location, tag_value.date)
    elif tag_value.type == TagType.DAYS:
        response = await weather_api.get_days(location, tag_value.days)
    else:
        raise ValueError(tag)
    return build_weather_response(request, response)
